<?php

class Sift extends Controller
{
	public $server = "mail.example.com";
	public $port = 2003;
	
	public function index()
	{
		if (empty($_SESSION['user']))
		{
			$this->load->view("login", array('msg' => "Please log in", 'title' => "Please log in"));
		}
	}
	
	public function login()
	{
		session_start(); 
		
		list($user, $domain) = explode("@", $_POST['email']);
		
		if (empty($domain))
		{
			$this->load->view("login", array("msg" => "Invalid address"));
			return false;
		}
		
		$sieve = new sieve($this->server, $this->port, $user, $_POST['password'], $user, "CRAM-MD5");
		
		if (!$sieve->sieve_login())
		{
			$this->load->view("login", array("msg" => "Login failed"));
			return false;
		}
		
		$_SESSION['user'] = $user;
		$_SESSION['password'] = $_POST['password'];
		$_SESSION['email'] = $_POST['email'];
		$_SESSION['server'] = $this->server;
		
		$data['msg'] = "{$_SERVER['HTTP_HOST']} / {$_SESSION['email']} / vacation message";
		$data['body'] = "";
		$data['subject'] = "";
		$data['enabled'] = "";
		
		$sieve->sieve_listscripts();
		
		$ret = $sieve->response;
		$data['enabled'] = "";
		
		if (isset($ret['ACTIVE'])) {
		  $data['enabled'] = ($ret['ACTIVE'] == 'sift_vacation') ? 'checked="true"' : "";
		}
		
		// Check if script is on
		$sieve->sieve_getscript("sift_vacation");
		
		$data['subject'] = substr($sieve->response[4], 10, -1);
		$body = array_slice($sieve->response, 5);
		$data['body'] = substr(implode("", $body), 1, -4);
		
		$sieve->sieve_logout();
		
		$this->load->view("vacation", $data);
		
	}
	
	public function logout()
	{
		session_destroy();
		$this->load->view("login", array('msg' => "Session closed", 'title' => "Please log in"));
	}
	
	public function vacation_submit()
	{
		session_start();
		
		$body = $_POST['vacation_msg'];
		$subject = $_POST['vacation_subject'];
		$enabled = isset($_POST['vacation_enable']);
		
		return ($enabled) ? $this->vacation_enable($subject, $body) : $this->vacation_disable();
		
	}
	
	public function vacation_disable($scriptname = "sift_vacation")
	{
		$sieve = $this->sieve_init();
		$sieve->sieve_deletescript($scriptname);
		$data['enabled'] = false;
		$data['msg'] = "Vacation message deactivated!";
		$this->load->view("vacation", $data);
	}
	
	private function sieve_init()
	{
		$sieve = new sieve($_SESSION['server'], 2003, $_SESSION['user'],
			$_SESSION['password'], $_SESSION['user'], "CRAM-MD5");
		$sieve->sieve_login();
		return $sieve;
	}
	
	public function vacation_enable($subject, $body)
	{
		$b = addslashes(addslashes($body));
		
		$sieve = $this->sieve_init();
		$script = <<<EOS
require "vacation";
vacation
:days 7
:addresses ["{$_SESSION['email']}"]
:subject "{$subject}"
"$b";
EOS;
		
		$sieve->sieve_sendscript("sift_vacation", $script);
		$sieve->sieve_setactivescript("sift_vacation");
		$sieve->sieve_logout();
		
		$data['body'] = $body;
		$data['subject'] = $subject;
		$data['enabled'] = 'checked="true"';
		$data['msg'] = "Vacation message activated!";
		
		$this->load->view("vacation", $data);
		
	}
}

?>